define(['require', 'https://d3js.org/d3.v5.min.js'], (function (requirejs, d3) { 'use strict';

  function _interopNamespace(e) {
    if (e && e.__esModule) return e;
    var n = Object.create(null);
    if (e) {
      Object.keys(e).forEach(function (k) {
        if (k !== 'default') {
          var d = Object.getOwnPropertyDescriptor(e, k);
          Object.defineProperty(n, k, d.get ? d : {
            enumerable: true,
            get: function () { return e[k]; }
          });
        }
      });
    }
    n["default"] = e;
    return Object.freeze(n);
  }

  var d3__namespace = /*#__PURE__*/_interopNamespace(d3);

  function _typeof(obj) {
    "@babel/helpers - typeof";

    return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) {
      return typeof obj;
    } : function (obj) {
      return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    }, _typeof(obj);
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    Object.defineProperty(Constructor, "prototype", {
      writable: false
    });
    return Constructor;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }

    Object.defineProperty(subClass, "prototype", {
      value: Object.create(superClass && superClass.prototype, {
        constructor: {
          value: subClass,
          writable: true,
          configurable: true
        }
      }),
      writable: false
    });
    if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };
    return _getPrototypeOf(o);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;
      return o;
    };

    return _setPrototypeOf(o, p);
  }

  function _isNativeReflectConstruct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;

    try {
      Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {}));
      return true;
    } catch (e) {
      return false;
    }
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return self;
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (typeof call === "object" || typeof call === "function")) {
      return call;
    } else if (call !== void 0) {
      throw new TypeError("Derived constructors may only return object or undefined");
    }

    return _assertThisInitialized(self);
  }

  function _createSuper(Derived) {
    var hasNativeReflectConstruct = _isNativeReflectConstruct();

    return function _createSuperInternal() {
      var Super = _getPrototypeOf(Derived),
          result;

      if (hasNativeReflectConstruct) {
        var NewTarget = _getPrototypeOf(this).constructor;

        result = Reflect.construct(Super, arguments, NewTarget);
      } else {
        result = Super.apply(this, arguments);
      }

      return _possibleConstructorReturn(this, result);
    };
  }

  var e = function () {
    function t(t, e) {
      this.name = t, this.slot = e || null, this.attributes = new Map();
    }

    return t.prototype.getName = function () {
      return this.name;
    }, t.prototype.getSlot = function () {
      return this.slot;
    }, t.prototype.getAttributes = function () {
      return this.attributes;
    }, t.slotLimit = function (e, n) {
      return new t("limit", e).attr("n", n);
    }, t.dataLimit = function (e) {
      return new t("limit").attr("n", e);
    }, t.prototype.attr = function (t, e) {
      return this.attributes.set(t, e), this;
    }, t;
  }(),
      _n = function n(t, e) {
    return (_n = Object.setPrototypeOf || {
      __proto__: []
    } instanceof Array && function (t, e) {
      t.__proto__ = e;
    } || function (t, e) {
      for (var n in e) {
        Object.prototype.hasOwnProperty.call(e, n) && (t[n] = e[n]);
      }
    })(t, e);
  };
  /*! *****************************************************************************
  Copyright (c) Microsoft Corporation.

  Permission to use, copy, modify, and/or distribute this software for any
  purpose with or without fee is hereby granted.

  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
  REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
  AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
  INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
  LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
  OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
  PERFORMANCE OF THIS SOFTWARE.
  ***************************************************************************** */


  function r(t, e) {
    function r() {
      this.constructor = t;
    }

    _n(t, e), t.prototype = null === e ? Object.create(e) : (r.prototype = e.prototype, new r());
  }

  function o(t, e, n) {
    return t.getDecoration(e, n);
  }

  function i(t) {
    return t.hasDecoration("hasSelection") ? o(t, "hasSelection", !1) : !!function (t) {
      return "getSlot" in t && "hasDecorationOnDataPoints" in t;
    }(t) && t.hasDecorationOnDataPoints("selected");
  }

  var u,
      s = function () {
    function t(t, e) {
      this.min = t, this.max = e;
    }

    return t.prototype.asArray = function () {
      return [this.min, this.max];
    }, t.empty = new t(0, 0), t;
  }(),
      a = function (t) {
    function e(e, n) {
      return t.call(this, e, n) || this;
    }

    return r(e, t), e.fromRS = function (t) {
      return new s(t.min, t.max);
    }, e;
  }(s),
      l = function () {
    function t(t, e) {
      this.source = t, this.index = e, this.key = t.getKey(!1), this.caption = t.getCaption("label") || "";
      var n = t.getItems() || [];
      this.segments = n.map(function (t) {
        return new p(t);
      });
    }

    return Object.defineProperty(t.prototype, "selected", {
      get: function get() {
        return o(this.source, "selected", !1);
      },
      enumerable: !1,
      configurable: !0
    }), Object.defineProperty(t.prototype, "highlighted", {
      get: function get() {
        return o(this.source, "highlighted", !1);
      },
      enumerable: !1,
      configurable: !0
    }), t;
  }(),
      c = function (t) {
    function e(e, n) {
      return t.call(this, e, n) || this;
    }

    return r(e, t), e;
  }(l),
      h = function () {
    function t(t) {
      this.source = t, this.key = this.source.getUniqueName() || "", this.caption = this.source.getCaption("label") || "";
    }

    return Object.defineProperty(t.prototype, "selected", {
      get: function get() {
        return o(this.source, "selected", !1);
      },
      enumerable: !1,
      configurable: !0
    }), Object.defineProperty(t.prototype, "highlighted", {
      get: function get() {
        return o(this.source, "highlighted", !1);
      },
      enumerable: !1,
      configurable: !0
    }), t;
  }(),
      p = function (t) {
    function e(e) {
      return t.call(this, e) || this;
    }

    return r(e, t), e;
  }(h),
      f = new (function () {
    function t() {}

    return t.prototype.format = function (t) {
      return t ? t.toString() : "";
    }, t;
  }())();

  !function (t) {
    t.label = "label", t.data = "data";
  }(u || (u = {}));

  var g = function () {
    function t(t, e, n, r, o) {
      this.source = t, this.tuples = e, this.segments = n, this.domain = r, this.caption = o;
      var i = t.dataItems || [],
          u = i.length > 0 ? i[0] : null,
          s = u && u.asCont();
      s ? (this._labelFormatter = s.getFormatter("label") || f, this._dataFormatter = s.getFormatter("data") || f) : this._labelFormatter = this._dataFormatter = f;
    }

    return Object.defineProperty(t.prototype, "mapped", {
      get: function get() {
        return this.source.mapped;
      },
      enumerable: !1,
      configurable: !0
    }), Object.defineProperty(t.prototype, "dataType", {
      get: function get() {
        var t = this.source.getDataItem(0);
        return this.mapped && t ? t.type : "none";
      },
      enumerable: !1,
      configurable: !0
    }), t.prototype.format = function (t, e) {
      return function (t, e) {
        return t.format(e);
      }(e === u.data ? this._dataFormatter : this._labelFormatter, t);
    }, t;
  }(),
      d = function (t) {
    function e(e, n, r, o, i) {
      return t.call(this, e, n, r, o, i) || this;
    }

    return r(e, t), e;
  }(g),
      m = function () {
    function t(t, e) {
      this.source = t, this.key = t.getKey(!1), this.dataSet = e;
    }

    return Object.defineProperty(t.prototype, "selected", {
      get: function get() {
        return o(this.source, "selected", !1);
      },
      enumerable: !1,
      configurable: !0
    }), Object.defineProperty(t.prototype, "highlighted", {
      get: function get() {
        return o(this.source, "highlighted", !1);
      },
      enumerable: !1,
      configurable: !0
    }), t.prototype.tuple = function (t) {
      var e = this._getSlot(t);

      if (!e || 0 === e.tuples.length) return null;
      var n = this.source.get(e.source);
      if (!n) return null;
      var r = n.asCat();
      return r ? e.tuples[r.index] : null;
    }, t.prototype.value = function (t) {
      var e = this._getSlot(t),
          n = e && this.source.get(e.source);

      if (!n) return null;
      var r = n.asCont();
      return r && "numeric" === r.valueType ? r.value : null;
    }, t.prototype.caption = function (t) {
      var e = this._getSlot(t),
          n = e && this.source.get(e.source);

      return n && n.getCaption("data") || "";
    }, t.prototype._getSlot = function (t) {
      return "string" == typeof t ? this.dataSet.slotMap.get(t) || null : this.dataSet.cols[t] || null;
    }, t;
  }(),
      y$1 = function (t) {
    function e(e, n) {
      return t.call(this, e, n) || this;
    }

    return r(e, t), e;
  }(m),
      v = function () {
    function t(t, e, n) {
      var r = this;
      this.source = t, this.rows = t.dataPoints.map(function (t) {
        return new y$1(t, r);
      }), this.cols = e, this.slotMap = n;
    }

    return t.filterRows = function (t, e, n) {
      return t.filter(function (t) {
        var r = t.tuple(e);
        return !!r && r.key === n;
      });
    }, Object.defineProperty(t.prototype, "hasSelections", {
      get: function get() {
        return i(this.source);
      },
      enumerable: !1,
      configurable: !0
    }), t;
  }(),
      _ = function (t) {
    function e(e, n, r) {
      return t.call(this, e, n, r) || this;
    }

    return r(e, t), e;
  }(v);

  function b(t) {
    var e = new Map(),
        n = t.getSlots().map(function (t, n) {
      var r = [],
          o = [],
          i = s.empty,
          u = "";

      if (t.isMapped()) {
        var l = t.getDataItem(0);
        if (u = l.getCaption("label"), "cat" === l.getRSType()) r = l.getTuples().map(function (t, e) {
          return new c(t, e);
        }), o = l.getItemClassSet(0).getItemClasses().map(function (t) {
          return new p(t);
        });else i = a.fromRS(l.getDomain()), o.push(new p(l.getItemClass()));
      }

      var h = new d(t, r, o, i, u);
      return e.set(t.name, h), h;
    });
    return new _(t, n, e);
  }

  function w(t) {
    return t < 0 ? 0 : t > 255 ? 255 : Math.floor(t);
  }

  var C = function () {
    function t(t, e, n, r) {
      var o;
      this.r = w(t), this.g = w(e), this.b = w(n), this.a = (o = r) < 0 ? 0 : o > 1 ? 1 : o;
    }

    return t.fromObject = function (e) {
      return new t(e.r, e.g, e.b, void 0 === e.a ? 1 : e.a);
    }, t.prototype.toString = function () {
      return 1 === this.a ? "rgb(" + this.r + "," + this.g + "," + this.b + ")" : "rgba(" + this.r + "," + this.g + "," + this.b + "," + this.a + ")";
    }, t;
  }();

  function S(t, e) {
    var n = null;
    if (t instanceof m) n = t.source.getDataSet(e);else {
      var r = t.source.getDataItem(e);
      n = r && r.getDataSet(e);
    }
    return !!n && i(n);
  }

  var P = function P(t) {
    return "rgba(" + t.r + "," + t.g + "," + t.b + ",0.4)";
  },
      j = function j(t) {
    return "rgba(" + Math.round(.7 * t.r) + "," + Math.round(.7 * t.g) + "," + Math.round(.7 * t.b) + "," + t.a + ")";
  },
      O = function () {
    function t(t, e, n) {
      this.source = t, this._dataContext = e, this._slotResolver = n;
    }

    return Object.defineProperty(t.prototype, "slot", {
      get: function get() {
        return this.source.slot;
      },
      enumerable: !1,
      configurable: !0
    }), t.prototype.getColor = function (t) {
      return t ? C.fromObject(this.source.getTupleColor(t.source, -1)) : C.fromObject(this.source.getColor(null));
    }, t.prototype._getTuple = function (t) {
      if (t instanceof l) return t;

      var e = this.slot || this._slotResolver(t.dataSet, this.source.name);

      return e ? t.tuple(e) : null;
    }, t.prototype.getFillColor = function (t) {
      if (null === t) return this.source.getColor(null).toString();

      var e,
          n = this._getTuple(t);

      return e = n ? this.source.getTupleColor(n.source, -1) : this.source.getColor(t.source), !t.selected && S(t, this._dataContext) ? P(e) : e.toString();
    }, t.prototype.getOutlineColor = function (t) {
      if (null === t) return this.source.getColor(null).toString();

      var e,
          n = this._getTuple(t);

      return e = n ? this.source.getTupleColor(n.source, -1) : this.source.getColor(t.source), t.highlighted || t.selected && S(t, this._dataContext) ? j(e) : null;
    }, t;
  }(),
      x$1 = function x(t, e, n) {
    this.color = t, this.at = e, this.value = n;
  };

  function I(t) {
    return t.map(function (t) {
      return new x$1(C.fromObject(t.color), t.at, t.value);
    });
  }

  var D = function () {
    function t(t, e, n) {
      this.source = t, this._slot = e, this._dataContext = n, this.stops = I(t.stops), this.aligned = I(t.aligned), this.interpolate = t.interpolate;
    }

    return t.prototype.getColor = function (t) {
      return C.fromObject(this.source.getColor(t));
    }, t.prototype.getFillColor = function (t) {
      var e = this._slot ? Number(t.value(this._slot)) : 0,
          n = this.source.getColor(e);
      return !t.selected && S(t, this._dataContext) ? P(n) : n.toString();
    }, t.prototype.getOutlineColor = function (t) {
      var e = this._slot ? Number(t.value(this._slot)) : 0,
          n = this.source.getColor(e);
      return t.highlighted || t.selected && S(t, this._dataContext) ? j(n) : null;
    }, t;
  }(),
      E = function () {
    function t(t, e, n) {
      this.source = t, this._dataContext = e, this._lastDataItem = null, this._cachedStops = null, this._slotResolver = n;
    }

    return Object.defineProperty(t.prototype, "slot", {
      get: function get() {
        return this.source.slot;
      },
      enumerable: !1,
      configurable: !0
    }), t.prototype.getColorStops = function (t) {
      var e = t ? t.source.getDataItem(0) : null,
          n = e && e.asCont(),
          r = n ? n.getDomain(null) : null,
          o = this.source.getColorStops(n, r),
          i = t ? t.source.name : null;
      return new D(o, i, this._dataContext);
    }, t.prototype._fetchColorStops = function (t) {
      var e = t.source.getDataSet(this._dataContext),
          n = this.slot || this._slotResolver(t.dataSet, this.source.name),
          r = n ? e.getSlot(n) : null,
          o = r ? r.getDataItem(0) : null,
          i = o ? o.asCont() : null;

      if (this.source.dirty || !this._cachedStops || i !== this._lastDataItem) {
        var u = i ? i.getDomain(null) : null,
            s = this.source.getColorStops(i, u);
        this._cachedStops = new D(s, r && r.name, this._dataContext), this._lastDataItem = i;
      }

      return this._cachedStops;
    }, t.prototype.getFillColor = function (t) {
      return this._fetchColorStops(t).getFillColor(t);
    }, t.prototype.getOutlineColor = function (t) {
      return this._fetchColorStops(t).getOutlineColor(t);
    }, t;
  }(),
      T = function (t) {
    function e(e) {
      var n = t.call(this, e.r, e.g, e.b, e.a) || this;
      return n._color = e, n;
    }

    return r(e, t), e.prototype.getRed = function () {
      return this.r;
    }, e.prototype.getGreen = function () {
      return this.g;
    }, e.prototype.getBlue = function () {
      return this.b;
    }, e.prototype.getAlpha = function () {
      return this.a;
    }, e;
  }(C),
      R = Object.freeze({
    min: 0,
    max: 0,
    empty: !0,
    explicit: !1,
    getMin: function getMin() {
      return 0;
    },
    getMax: function getMax() {
      return 0;
    },
    isEmpty: function isEmpty() {
      return !0;
    },
    isExplicit: function isExplicit() {
      return !1;
    }
  }),
      F = function () {
    function t(t, e, n, r, o, i) {
      this.caption = t, this.color = e, this.shape = n, this.selected = r, this.highlighted = o, this.ref = i;
    }

    return t.prototype.getCaption = function () {
      return this.caption;
    }, t.prototype.getColor = function () {
      return this.color ? new T(this.color) : null;
    }, t.prototype.getShape = function () {
      return this.shape;
    }, t.prototype.isSelected = function () {
      return this.selected;
    }, t.prototype.isHighlighted = function () {
      return this.highlighted;
    }, t.prototype.getRef = function () {
      return this.ref;
    }, t;
  }(),
      M = function () {
    function t(t, e, n, r, o, i) {
      this.type = t, this.channel = e, this.slot = n, this.caption = r, this.subCaption = o, this.ref = i;
    }

    return t.prototype.getRSType = function () {
      return this.type;
    }, t.prototype.getChannel = function () {
      return this.channel;
    }, t.prototype.getSlot = function () {
      return this.slot;
    }, t.prototype.getCaption = function () {
      return this.caption;
    }, t.prototype.getSubCaption = function () {
      return this.subCaption;
    }, t.prototype.getRef = function () {
      return this.ref;
    }, t;
  }(),
      L = function (t) {
    function e(e, n, r, i, u) {
      var s = this,
          a = n && n.source,
          l = a && a.name,
          c = a && a.getDataItem(0),
          h = c && c.asCat();
      s = t.call(this, "cat", e, l, r, "", h) || this;
      var p = h ? h.tuples : [];
      return s.entries = p.map(function (t) {
        var e = t.getCaption("label") || "",
            n = u && u.source.getTupleColor(t, -1),
            r = o(t, "selected", !1),
            s = o(t, "highlighted", !1);
        return new F(e, n ? C.fromObject(n) : null, i, r, s, t);
      }), s;
    }

    return r(e, t), e.prototype.getEntries = function () {
      return this.entries;
    }, e;
  }(M),
      A = function (t) {
    function e(e, n, r, o) {
      var i = this,
          u = n && n.source,
          s = u && u.name,
          a = u && u.getDataItem(0),
          l = a && a.asCont();

      if ((i = t.call(this, "cont", e, s, r, "", l) || this).domain = l ? l.getDomain(null) : R, o && "color" === e) {
        var c = o.source.getColorStops(l, null);
        i.stops = c.stops, i.interpolate = c.interpolate;
      } else i.stops = null, i.interpolate = !1;

      return i;
    }

    return r(e, t), e.prototype.getDomain = function () {
      return this.domain;
    }, e.prototype.getInterpolate = function () {
      return this.interpolate;
    }, e.prototype.getStops = function () {
      return this.stops;
    }, e;
  }(M);

  function z(t, e, n, r) {
    if (!t) return [];
    var o = new Map(),
        i = new Map();
    e.palettes.forEach(function (e) {
      var n = e.slot || r && r(t, e.source.name);
      n && (e instanceof O ? o.set(n, e) : e instanceof E && i.set(n, e));
    });
    var u = [];
    return t.cols.forEach(function (t) {
      var e = t.source;

      if (e.mapped) {
        var r = e.getDataItem(0);
        if (r) switch (r.type) {
          case "cat":
            if (-1 === e.channels.indexOf("color")) return;
            var s = o.get(e.name);
            s && u.push(new L("color", t, t.caption, n.legendShape, s));
            break;

          case "cont":
            if (-1 !== e.channels.indexOf("color")) {
              var a = i.get(e.name);
              a && u.push(new A("color", t, t.caption, a));
            }

            -1 !== e.channels.indexOf("size") && u.push(new A("size", t, t.caption, null));
        }
      }
    }), u;
  }

  var N,
      k = function k() {
    this.legendShape = null, this.slotLimits = new Map(), this.dataLimit = -1;
  };

  !function (t) {
    t.Em = "em", t.Percentage = "%", t.Centimeter = "cm", t.Millimeter = "mm", t.Inch = "in", t.Pica = "pc", t.Point = "pt", t.Pixel = "px";
  }(N || (N = {}));

  var H,
      U,
      V = function () {
    function t(t, e) {
      this.value = t, this.unit = e;
    }

    return t.fromObject = function (e) {
      return new t(e.value, function (t) {
        switch (t) {
          case "em":
            return N.Em;

          case "%":
            return N.Percentage;

          case "cm":
            return N.Centimeter;

          case "mm":
            return N.Millimeter;

          case "in":
            return N.Inch;

          case "pc":
            return N.Pica;

          case "pt":
            return N.Point;

          case "px":
            return N.Pixel;

          default:
            throw new Error("Invalid length unit '" + t + "' specified");
        }
      }(e.unit));
    }, t.prototype.toString = function () {
      return "" + this.value + this.unit;
    }, t;
  }();

  !function (t) {
    t.Normal = "normal", t.Italic = "italic";
  }(H || (H = {})), function (t) {
    t[t.Thin = 100] = "Thin", t[t.ExtraLight = 200] = "ExtraLight", t[t.Light = 300] = "Light", t[t.Normal = 400] = "Normal", t[t.Medium = 500] = "Medium", t[t.SemiBold = 600] = "SemiBold", t[t.Bold = 700] = "Bold", t[t.ExtraBold = 800] = "ExtraBold", t[t.Heavy = 900] = "Heavy";
  }(U || (U = {}));
  var q = /\s+/g;

  function K(t) {
    switch (t) {
      case U.Normal:
        return "normal";

      case U.Bold:
        return "bold";

      case U.Thin:
      case U.ExtraLight:
      case U.Light:
      case U.Medium:
      case U.SemiBold:
      case U.ExtraBold:
      case U.Heavy:
        return t.toString();

      default:
        return "";
    }
  }

  function G(t) {
    var e = [];
    if (t) for (var n = 0, r = t.length; n < r; ++n) {
      var o = t[n],
          i = q.test(o);
      e.push(i ? '"' + o + '"' : o);
    }
    return e.join(", ");
  }

  var J = function () {
    function t(t, e, n, r) {
      this.family = t, this.size = e, this.style = n, this.weight = r;
    }

    return t.fromObject = function (e) {
      return new t(e.family || null, e.size ? V.fromObject(e.size) : null, e.style ? function (t) {
        switch (t) {
          case "normal":
            return H.Normal;

          case "italic":
            return H.Italic;

          default:
            throw new Error("Invalid font style '" + t + "' specified");
        }
      }(e.style) : null, void 0 !== e.weight && null !== e.weight ? e.weight : null);
    }, t.prototype.toString = function () {
      if (this.style !== H.Normal && this.weight !== U.Normal || this.style === H.Normal && this.weight === U.Normal) {
        var t = [];
        return this.style === H.Normal ? t.push("normal") : (this.style && t.push(this.style), this.weight && t.push(K(this.weight))), this.size && t.push(this.size.toString()), this.family && t.push(G(this.family)), t.join(" ");
      }

      return function (t) {
        var e,
            n = [],
            r = G(t.family);
        return r.length > 0 && n.push("font-family: " + r + ";"), (r = t.size ? t.size.toString() : "").length > 0 && n.push("font-size: " + r + ";"), (r = (e = t.style) ? e.toString() : "").length > 0 && n.push("font-style: " + r + ";"), (r = K(t.weight)).length > 0 && n.push("font-weight: " + r + ";"), n.join(" ");
      }(this);
    }, t;
  }(),
      Q = function () {
    function t(t, e, n) {
      var r = new Map();
      null !== t && t.forEach(function (t, o) {
        if ("palette" === t.type) {
          var i = t;

          switch (i.paletteType) {
            case "cat":
              r.set(o, new O(i, e, n));
              break;

            case "cont":
              r.set(o, new E(i, e, n));
          }
        }
      }), this.source = t, this.palettes = r;
    }

    return t.prototype.get = function (t) {
      return this._getValue(t, !1);
    }, t.prototype.peek = function (t) {
      return this._getValue(t, !0);
    }, t.prototype._getValue = function (t, e) {
      var n = this.source && this.source.get(t);
      if (!n) return null;

      switch (n.type) {
        case "string":
        case "number":
        case "boolean":
        case "enum":
          return e ? n.peek : n.value;

        case "length":
          var r = e ? n.peek : n.value;
          return r ? V.fromObject(r) : null;

        case "font":
          var o = e ? n.peek : n.value;
          return o ? J.fromObject(o) : null;

        case "color":
          var i = e ? n.peek : n.value;
          return i ? C.fromObject(i) : null;

        case "palette":
          return this.palettes.get(t) || null;

        default:
          return null;
      }
    }, t.prototype.isActive = function (t) {
      var e = this.source && this.source.get(t);
      return !!e && e.active;
    }, t.prototype.setActive = function (t, e) {
      var n = this.source && this.source.get(t);
      n && n.setActive(e);
    }, t.prototype.isDirty = function (t) {
      var e = this.source && this.source.get(t);
      return !!e && e.dirty;
    }, t;
  }();

  var W = setTimeout;

  function X(t) {
    return Boolean(t && void 0 !== t.length);
  }

  function Y() {}

  function Z(t) {
    if (!(this instanceof Z)) throw new TypeError("Promises must be constructed via new");
    if ("function" != typeof t) throw new TypeError("not a function");
    this._state = 0, this._handled = !1, this._value = void 0, this._deferreds = [], ot(t, this);
  }

  function $(t, e) {
    for (; 3 === t._state;) {
      t = t._value;
    }

    0 !== t._state ? (t._handled = !0, Z._immediateFn(function () {
      var n = 1 === t._state ? e.onFulfilled : e.onRejected;

      if (null !== n) {
        var r;

        try {
          r = n(t._value);
        } catch (t) {
          return void et(e.promise, t);
        }

        tt(e.promise, r);
      } else (1 === t._state ? tt : et)(e.promise, t._value);
    })) : t._deferreds.push(e);
  }

  function tt(t, e) {
    try {
      if (e === t) throw new TypeError("A promise cannot be resolved with itself.");

      if (e && ("object" == _typeof(e) || "function" == typeof e)) {
        var n = e.then;
        if (e instanceof Z) return t._state = 3, t._value = e, void nt(t);
        if ("function" == typeof n) return void ot((r = n, o = e, function () {
          r.apply(o, arguments);
        }), t);
      }

      t._state = 1, t._value = e, nt(t);
    } catch (e) {
      et(t, e);
    }

    var r, o;
  }

  function et(t, e) {
    t._state = 2, t._value = e, nt(t);
  }

  function nt(t) {
    2 === t._state && 0 === t._deferreds.length && Z._immediateFn(function () {
      t._handled || Z._unhandledRejectionFn(t._value);
    });

    for (var e = 0, n = t._deferreds.length; e < n; e++) {
      $(t, t._deferreds[e]);
    }

    t._deferreds = null;
  }

  function rt(t, e, n) {
    this.onFulfilled = "function" == typeof t ? t : null, this.onRejected = "function" == typeof e ? e : null, this.promise = n;
  }

  function ot(t, e) {
    var n = !1;

    try {
      t(function (t) {
        n || (n = !0, tt(e, t));
      }, function (t) {
        n || (n = !0, et(e, t));
      });
    } catch (t) {
      if (n) return;
      n = !0, et(e, t);
    }
  }

  Z.prototype["catch"] = function (t) {
    return this.then(null, t);
  }, Z.prototype.then = function (t, e) {
    var n = new this.constructor(Y);
    return $(this, new rt(t, e, n)), n;
  }, Z.prototype["finally"] = function (t) {
    var e = this.constructor;
    return this.then(function (n) {
      return e.resolve(t()).then(function () {
        return n;
      });
    }, function (n) {
      return e.resolve(t()).then(function () {
        return e.reject(n);
      });
    });
  }, Z.all = function (t) {
    return new Z(function (e, n) {
      if (!X(t)) return n(new TypeError("Promise.all accepts an array"));
      var r = Array.prototype.slice.call(t);
      if (0 === r.length) return e([]);
      var o = r.length;

      function i(t, u) {
        try {
          if (u && ("object" == _typeof(u) || "function" == typeof u)) {
            var s = u.then;
            if ("function" == typeof s) return void s.call(u, function (e) {
              i(t, e);
            }, n);
          }

          r[t] = u, 0 == --o && e(r);
        } catch (t) {
          n(t);
        }
      }

      for (var u = 0; u < r.length; u++) {
        i(u, r[u]);
      }
    });
  }, Z.resolve = function (t) {
    return t && "object" == _typeof(t) && t.constructor === Z ? t : new Z(function (e) {
      e(t);
    });
  }, Z.reject = function (t) {
    return new Z(function (e, n) {
      n(t);
    });
  }, Z.race = function (t) {
    return new Z(function (e, n) {
      if (!X(t)) return n(new TypeError("Promise.race accepts an array"));

      for (var r = 0, o = t.length; r < o; r++) {
        Z.resolve(t[r]).then(e, n);
      }
    });
  }, Z._immediateFn = "function" == typeof setImmediate && function (t) {
    setImmediate(t);
  } || function (t) {
    W(t, 0);
  }, Z._unhandledRejectionFn = function (t) {
    "undefined" != typeof console && console && console.warn("Possible Unhandled Promise Rejection:", t);
  };

  var it = function it(t, e, n, r) {
    this.data = t, this.decorations = e, this.properties = n, this.size = r;
  },
      ut = function ut(t, e, n, r, o) {
    this.reason = t, this.data = e, this.node = n, this.props = r, this.locale = o;
  };

  var st = function () {
    function n() {
      this._data = null, this._elem = null, this._nls = null, this._locale = "en-us", this._slotResolver = this.getSlotForPalette.bind(this), this.properties = new Q(null, null, this._slotResolver), this.meta = new k();
    }

    return n.prototype.init = function (t, e) {
      var n = this,
          r = t.surface.appendChild(document.createElement("div"));
      r.setAttribute("style", "left: 0; top: 0; width: 100%; height: 100%; position: absolute"), r.setAttribute("data-charttype", "custom-viz"), this.properties = new Q(t.properties, t.dataContext, this._slotResolver), this._nls = t.nls, this._locale = t.locale, Z.resolve(this.create(r)).then(function (o) {
        n._elem = o || r, t.properties.forEach(function (t, e) {
          return n.updateProperty(e, t.value);
        }), e.complete();
      })["catch"](function (t) {
        e.fail(t);
      });
    }, n.prototype.destroy = function () {}, n.prototype.getPropertyApi = function () {
      return null;
    }, n.prototype.setData = function (t) {
      t && t.dataSets && t.dataSets[0] ? this._data = b(t.dataSets[0]) : this._data = null;
    }, n.prototype.setProperty = function (t, e) {
      this.updateProperty(t, this.properties.peek(t));
    }, n.prototype.getBlockingRequests = function () {
      return null;
    }, n.prototype.render = function (t, e, n) {
      if (!this._elem) return n.complete(null, null, null), null;
      if (!(e.data || e.decorations || e.properties || e.size)) return n.complete(null, null, null), null;

      try {
        var r = this.update(new ut(function (t) {
          return new it(t.data, t.decorations, t.properties, t.size);
        }(e), this._data, this._elem, this.properties, this._locale));
        Z.resolve(r).then(function () {
          return n.complete(null, null, null);
        })["catch"](n.error);
      } catch (t) {
        n.error(t);
      }

      return null;
    }, n.prototype.getEncodings = function () {
      return this._data ? this.updateLegend(this._data) : [];
    }, n.prototype.getCapabilities = function () {
      var t = [];
      return this.meta.slotLimits.forEach(function (n, r) {
        t.push(e.slotLimit(r, n));
      }), this.meta.dataLimit >= 0 && t.push(e.dataLimit(this.meta.dataLimit)), t;
    }, n.prototype.getInteractivity = function () {
      return null;
    }, n.prototype.getVisCoordinate = function (t, e) {
      return e;
    }, n.prototype.getRegionAtPoint = function (t, e) {
      return null;
    }, n.prototype.getItemsAtPoint = function (t, e, n) {
      if (!t || !t.hasOwnProperty("x") || !t.hasOwnProperty("y")) return null;
      var r = t,
          o = document.elementFromPoint(r.x, r.y),
          i = this.hitTest(o, r, e);
      return i && i.source ? [i.source] : [];
    }, n.prototype.getItemsInPolygon = function (t, e) {
      return [];
    }, n.prototype.getAxisItemsAtPoint = function (t, e, n) {
      return [];
    }, n.prototype.getState = function () {
      return null;
    }, n.prototype.setState = function (t) {}, n.prototype.loadCss = function (t) {
      var e = document.createElement("link");
      e.type = "text/css", e.rel = "stylesheet", e.href = this.toUrl(t), document.getElementsByTagName("head")[0].appendChild(e);
    }, n.prototype.toUrl = function (e) {
      return requirejs.toUrl(e);
    }, n.prototype.update = function (t) {}, n.prototype.create = function (t) {}, n.prototype.updateProperty = function (t, e) {}, n.prototype.updateLegend = function (t) {
      return z(t, this.properties, this.meta, this._slotResolver);
    }, n.prototype.getSlotForPalette = function (t, e) {
      return null;
    }, n.prototype.hitTest = function (t, e, n) {
      var r = t && t.__data__;
      return r && r.source ? r : null;
    }, n.prototype.nls = function (t) {
      return this._nls && this._nls.get(t) || "";
    }, n;
  }();

  function max(values, valueof) {
    let max;
    if (valueof === undefined) {
      for (const value of values) {
        if (value != null
            && (max < value || (max === undefined && value >= value))) {
          max = value;
        }
      }
    } else {
      let index = -1;
      for (let value of values) {
        if ((value = valueof(value, ++index, values)) != null
            && (max < value || (max === undefined && value >= value))) {
          max = value;
        }
      }
    }
    return max;
  }

  function min(values, valueof) {
    let min;
    if (valueof === undefined) {
      for (const value of values) {
        if (value != null
            && (min > value || (min === undefined && value >= value))) {
          min = value;
        }
      }
    } else {
      let index = -1;
      for (let value of values) {
        if ((value = valueof(value, ++index, values)) != null
            && (min > value || (min === undefined && value >= value))) {
          min = value;
        }
      }
    }
    return min;
  }

  function sum(values, valueof) {
    let sum = 0;
    if (valueof === undefined) {
      for (let value of values) {
        if (value = +value) {
          sum += value;
        }
      }
    } else {
      let index = -1;
      for (let value of values) {
        if (value = +valueof(value, ++index, values)) {
          sum += value;
        }
      }
    }
    return sum;
  }

  function justify(node, n) {
    return node.sourceLinks.length ? node.depth : n - 1;
  }

  function constant$1(x) {
    return function() {
      return x;
    };
  }

  function ascendingSourceBreadth(a, b) {
    return ascendingBreadth(a.source, b.source) || a.index - b.index;
  }

  function ascendingTargetBreadth(a, b) {
    return ascendingBreadth(a.target, b.target) || a.index - b.index;
  }

  function ascendingBreadth(a, b) {
    return a.y0 - b.y0;
  }

  function value(d) {
    return d.value;
  }

  function defaultId(d) {
    return d.index;
  }

  function defaultNodes(graph) {
    return graph.nodes;
  }

  function defaultLinks(graph) {
    return graph.links;
  }

  function find(nodeById, id) {
    const node = nodeById.get(id);
    if (!node) throw new Error("missing: " + id);
    return node;
  }

  function computeLinkBreadths({nodes}) {
    for (const node of nodes) {
      let y0 = node.y0;
      let y1 = y0;
      for (const link of node.sourceLinks) {
        link.y0 = y0 + link.width / 2;
        y0 += link.width;
      }
      for (const link of node.targetLinks) {
        link.y1 = y1 + link.width / 2;
        y1 += link.width;
      }
    }
  }

  function Sankey$1() {
    let x0 = 0, y0 = 0, x1 = 1, y1 = 1; // extent
    let dx = 24; // nodeWidth
    let dy = 8, py; // nodePadding
    let id = defaultId;
    let align = justify;
    let sort;
    let linkSort;
    let nodes = defaultNodes;
    let links = defaultLinks;
    let iterations = 6;

    function sankey() {
      const graph = {nodes: nodes.apply(null, arguments), links: links.apply(null, arguments)};
      computeNodeLinks(graph);
      computeNodeValues(graph);
      computeNodeDepths(graph);
      computeNodeHeights(graph);
      computeNodeBreadths(graph);
      computeLinkBreadths(graph);
      return graph;
    }

    sankey.update = function(graph) {
      computeLinkBreadths(graph);
      return graph;
    };

    sankey.nodeId = function(_) {
      return arguments.length ? (id = typeof _ === "function" ? _ : constant$1(_), sankey) : id;
    };

    sankey.nodeAlign = function(_) {
      return arguments.length ? (align = typeof _ === "function" ? _ : constant$1(_), sankey) : align;
    };

    sankey.nodeSort = function(_) {
      return arguments.length ? (sort = _, sankey) : sort;
    };

    sankey.nodeWidth = function(_) {
      return arguments.length ? (dx = +_, sankey) : dx;
    };

    sankey.nodePadding = function(_) {
      return arguments.length ? (dy = py = +_, sankey) : dy;
    };

    sankey.nodes = function(_) {
      return arguments.length ? (nodes = typeof _ === "function" ? _ : constant$1(_), sankey) : nodes;
    };

    sankey.links = function(_) {
      return arguments.length ? (links = typeof _ === "function" ? _ : constant$1(_), sankey) : links;
    };

    sankey.linkSort = function(_) {
      return arguments.length ? (linkSort = _, sankey) : linkSort;
    };

    sankey.size = function(_) {
      return arguments.length ? (x0 = y0 = 0, x1 = +_[0], y1 = +_[1], sankey) : [x1 - x0, y1 - y0];
    };

    sankey.extent = function(_) {
      return arguments.length ? (x0 = +_[0][0], x1 = +_[1][0], y0 = +_[0][1], y1 = +_[1][1], sankey) : [[x0, y0], [x1, y1]];
    };

    sankey.iterations = function(_) {
      return arguments.length ? (iterations = +_, sankey) : iterations;
    };

    function computeNodeLinks({nodes, links}) {
      for (const [i, node] of nodes.entries()) {
        node.index = i;
        node.sourceLinks = [];
        node.targetLinks = [];
      }
      const nodeById = new Map(nodes.map((d, i) => [id(d, i, nodes), d]));
      for (const [i, link] of links.entries()) {
        link.index = i;
        let {source, target} = link;
        if (typeof source !== "object") source = link.source = find(nodeById, source);
        if (typeof target !== "object") target = link.target = find(nodeById, target);
        source.sourceLinks.push(link);
        target.targetLinks.push(link);
      }
      if (linkSort != null) {
        for (const {sourceLinks, targetLinks} of nodes) {
          sourceLinks.sort(linkSort);
          targetLinks.sort(linkSort);
        }
      }
    }

    function computeNodeValues({nodes}) {
      for (const node of nodes) {
        node.value = node.fixedValue === undefined
            ? Math.max(sum(node.sourceLinks, value), sum(node.targetLinks, value))
            : node.fixedValue;
      }
    }

    function computeNodeDepths({nodes}) {
      const n = nodes.length;
      let current = new Set(nodes);
      let next = new Set;
      let x = 0;
      while (current.size) {
        for (const node of current) {
          node.depth = x;
          for (const {target} of node.sourceLinks) {
            next.add(target);
          }
        }
        if (++x > n) throw new Error("circular link");
        current = next;
        next = new Set;
      }
    }

    function computeNodeHeights({nodes}) {
      const n = nodes.length;
      let current = new Set(nodes);
      let next = new Set;
      let x = 0;
      while (current.size) {
        for (const node of current) {
          node.height = x;
          for (const {source} of node.targetLinks) {
            next.add(source);
          }
        }
        if (++x > n) throw new Error("circular link");
        current = next;
        next = new Set;
      }
    }

    function computeNodeLayers({nodes}) {
      const x = max(nodes, d => d.depth) + 1;
      const kx = (x1 - x0 - dx) / (x - 1);
      const columns = new Array(x);
      for (const node of nodes) {
        const i = Math.max(0, Math.min(x - 1, Math.floor(align.call(null, node, x))));
        node.layer = i;
        node.x0 = x0 + i * kx;
        node.x1 = node.x0 + dx;
        if (columns[i]) columns[i].push(node);
        else columns[i] = [node];
      }
      if (sort) for (const column of columns) {
        column.sort(sort);
      }
      return columns;
    }

    function initializeNodeBreadths(columns) {
      const ky = min(columns, c => (y1 - y0 - (c.length - 1) * py) / sum(c, value));
      for (const nodes of columns) {
        let y = y0;
        for (const node of nodes) {
          node.y0 = y;
          node.y1 = y + node.value * ky;
          y = node.y1 + py;
          for (const link of node.sourceLinks) {
            link.width = link.value * ky;
          }
        }
        y = (y1 - y + py) / (nodes.length + 1);
        for (let i = 0; i < nodes.length; ++i) {
          const node = nodes[i];
          node.y0 += y * (i + 1);
          node.y1 += y * (i + 1);
        }
        reorderLinks(nodes);
      }
    }

    function computeNodeBreadths(graph) {
      const columns = computeNodeLayers(graph);
      py = Math.min(dy, (y1 - y0) / (max(columns, c => c.length) - 1));
      initializeNodeBreadths(columns);
      for (let i = 0; i < iterations; ++i) {
        const alpha = Math.pow(0.99, i);
        const beta = Math.max(1 - alpha, (i + 1) / iterations);
        relaxRightToLeft(columns, alpha, beta);
        relaxLeftToRight(columns, alpha, beta);
      }
    }

    // Reposition each node based on its incoming (target) links.
    function relaxLeftToRight(columns, alpha, beta) {
      for (let i = 1, n = columns.length; i < n; ++i) {
        const column = columns[i];
        for (const target of column) {
          let y = 0;
          let w = 0;
          for (const {source, value} of target.targetLinks) {
            let v = value * (target.layer - source.layer);
            y += targetTop(source, target) * v;
            w += v;
          }
          if (!(w > 0)) continue;
          let dy = (y / w - target.y0) * alpha;
          target.y0 += dy;
          target.y1 += dy;
          reorderNodeLinks(target);
        }
        if (sort === undefined) column.sort(ascendingBreadth);
        resolveCollisions(column, beta);
      }
    }

    // Reposition each node based on its outgoing (source) links.
    function relaxRightToLeft(columns, alpha, beta) {
      for (let n = columns.length, i = n - 2; i >= 0; --i) {
        const column = columns[i];
        for (const source of column) {
          let y = 0;
          let w = 0;
          for (const {target, value} of source.sourceLinks) {
            let v = value * (target.layer - source.layer);
            y += sourceTop(source, target) * v;
            w += v;
          }
          if (!(w > 0)) continue;
          let dy = (y / w - source.y0) * alpha;
          source.y0 += dy;
          source.y1 += dy;
          reorderNodeLinks(source);
        }
        if (sort === undefined) column.sort(ascendingBreadth);
        resolveCollisions(column, beta);
      }
    }

    function resolveCollisions(nodes, alpha) {
      const i = nodes.length >> 1;
      const subject = nodes[i];
      resolveCollisionsBottomToTop(nodes, subject.y0 - py, i - 1, alpha);
      resolveCollisionsTopToBottom(nodes, subject.y1 + py, i + 1, alpha);
      resolveCollisionsBottomToTop(nodes, y1, nodes.length - 1, alpha);
      resolveCollisionsTopToBottom(nodes, y0, 0, alpha);
    }

    // Push any overlapping nodes down.
    function resolveCollisionsTopToBottom(nodes, y, i, alpha) {
      for (; i < nodes.length; ++i) {
        const node = nodes[i];
        const dy = (y - node.y0) * alpha;
        if (dy > 1e-6) node.y0 += dy, node.y1 += dy;
        y = node.y1 + py;
      }
    }

    // Push any overlapping nodes up.
    function resolveCollisionsBottomToTop(nodes, y, i, alpha) {
      for (; i >= 0; --i) {
        const node = nodes[i];
        const dy = (node.y1 - y) * alpha;
        if (dy > 1e-6) node.y0 -= dy, node.y1 -= dy;
        y = node.y0 - py;
      }
    }

    function reorderNodeLinks({sourceLinks, targetLinks}) {
      if (linkSort === undefined) {
        for (const {source: {sourceLinks}} of targetLinks) {
          sourceLinks.sort(ascendingTargetBreadth);
        }
        for (const {target: {targetLinks}} of sourceLinks) {
          targetLinks.sort(ascendingSourceBreadth);
        }
      }
    }

    function reorderLinks(nodes) {
      if (linkSort === undefined) {
        for (const {sourceLinks, targetLinks} of nodes) {
          sourceLinks.sort(ascendingTargetBreadth);
          targetLinks.sort(ascendingSourceBreadth);
        }
      }
    }

    // Returns the target.y0 that would produce an ideal link from source to target.
    function targetTop(source, target) {
      let y = source.y0 - (source.sourceLinks.length - 1) * py / 2;
      for (const {target: node, width} of source.sourceLinks) {
        if (node === target) break;
        y += width + py;
      }
      for (const {source: node, width} of target.targetLinks) {
        if (node === source) break;
        y -= width;
      }
      return y;
    }

    // Returns the source.y0 that would produce an ideal link from source to target.
    function sourceTop(source, target) {
      let y = target.y0 - (target.targetLinks.length - 1) * py / 2;
      for (const {source: node, width} of target.targetLinks) {
        if (node === source) break;
        y += width + py;
      }
      for (const {target: node, width} of source.sourceLinks) {
        if (node === target) break;
        y -= width;
      }
      return y;
    }

    return sankey;
  }

  var pi = Math.PI,
      tau = 2 * pi,
      epsilon = 1e-6,
      tauEpsilon = tau - epsilon;

  function Path() {
    this._x0 = this._y0 = // start of current subpath
    this._x1 = this._y1 = null; // end of current subpath
    this._ = "";
  }

  function path() {
    return new Path;
  }

  Path.prototype = path.prototype = {
    constructor: Path,
    moveTo: function(x, y) {
      this._ += "M" + (this._x0 = this._x1 = +x) + "," + (this._y0 = this._y1 = +y);
    },
    closePath: function() {
      if (this._x1 !== null) {
        this._x1 = this._x0, this._y1 = this._y0;
        this._ += "Z";
      }
    },
    lineTo: function(x, y) {
      this._ += "L" + (this._x1 = +x) + "," + (this._y1 = +y);
    },
    quadraticCurveTo: function(x1, y1, x, y) {
      this._ += "Q" + (+x1) + "," + (+y1) + "," + (this._x1 = +x) + "," + (this._y1 = +y);
    },
    bezierCurveTo: function(x1, y1, x2, y2, x, y) {
      this._ += "C" + (+x1) + "," + (+y1) + "," + (+x2) + "," + (+y2) + "," + (this._x1 = +x) + "," + (this._y1 = +y);
    },
    arcTo: function(x1, y1, x2, y2, r) {
      x1 = +x1, y1 = +y1, x2 = +x2, y2 = +y2, r = +r;
      var x0 = this._x1,
          y0 = this._y1,
          x21 = x2 - x1,
          y21 = y2 - y1,
          x01 = x0 - x1,
          y01 = y0 - y1,
          l01_2 = x01 * x01 + y01 * y01;

      // Is the radius negative? Error.
      if (r < 0) throw new Error("negative radius: " + r);

      // Is this path empty? Move to (x1,y1).
      if (this._x1 === null) {
        this._ += "M" + (this._x1 = x1) + "," + (this._y1 = y1);
      }

      // Or, is (x1,y1) coincident with (x0,y0)? Do nothing.
      else if (!(l01_2 > epsilon));

      // Or, are (x0,y0), (x1,y1) and (x2,y2) collinear?
      // Equivalently, is (x1,y1) coincident with (x2,y2)?
      // Or, is the radius zero? Line to (x1,y1).
      else if (!(Math.abs(y01 * x21 - y21 * x01) > epsilon) || !r) {
        this._ += "L" + (this._x1 = x1) + "," + (this._y1 = y1);
      }

      // Otherwise, draw an arc!
      else {
        var x20 = x2 - x0,
            y20 = y2 - y0,
            l21_2 = x21 * x21 + y21 * y21,
            l20_2 = x20 * x20 + y20 * y20,
            l21 = Math.sqrt(l21_2),
            l01 = Math.sqrt(l01_2),
            l = r * Math.tan((pi - Math.acos((l21_2 + l01_2 - l20_2) / (2 * l21 * l01))) / 2),
            t01 = l / l01,
            t21 = l / l21;

        // If the start tangent is not coincident with (x0,y0), line to.
        if (Math.abs(t01 - 1) > epsilon) {
          this._ += "L" + (x1 + t01 * x01) + "," + (y1 + t01 * y01);
        }

        this._ += "A" + r + "," + r + ",0,0," + (+(y01 * x20 > x01 * y20)) + "," + (this._x1 = x1 + t21 * x21) + "," + (this._y1 = y1 + t21 * y21);
      }
    },
    arc: function(x, y, r, a0, a1, ccw) {
      x = +x, y = +y, r = +r, ccw = !!ccw;
      var dx = r * Math.cos(a0),
          dy = r * Math.sin(a0),
          x0 = x + dx,
          y0 = y + dy,
          cw = 1 ^ ccw,
          da = ccw ? a0 - a1 : a1 - a0;

      // Is the radius negative? Error.
      if (r < 0) throw new Error("negative radius: " + r);

      // Is this path empty? Move to (x0,y0).
      if (this._x1 === null) {
        this._ += "M" + x0 + "," + y0;
      }

      // Or, is (x0,y0) not coincident with the previous point? Line to (x0,y0).
      else if (Math.abs(this._x1 - x0) > epsilon || Math.abs(this._y1 - y0) > epsilon) {
        this._ += "L" + x0 + "," + y0;
      }

      // Is this arc empty? We’re done.
      if (!r) return;

      // Does the angle go the wrong way? Flip the direction.
      if (da < 0) da = da % tau + tau;

      // Is this a complete circle? Draw two arcs to complete the circle.
      if (da > tauEpsilon) {
        this._ += "A" + r + "," + r + ",0,1," + cw + "," + (x - dx) + "," + (y - dy) + "A" + r + "," + r + ",0,1," + cw + "," + (this._x1 = x0) + "," + (this._y1 = y0);
      }

      // Is this arc non-empty? Draw an arc!
      else if (da > epsilon) {
        this._ += "A" + r + "," + r + ",0," + (+(da >= pi)) + "," + cw + "," + (this._x1 = x + r * Math.cos(a1)) + "," + (this._y1 = y + r * Math.sin(a1));
      }
    },
    rect: function(x, y, w, h) {
      this._ += "M" + (this._x0 = this._x1 = +x) + "," + (this._y0 = this._y1 = +y) + "h" + (+w) + "v" + (+h) + "h" + (-w) + "Z";
    },
    toString: function() {
      return this._;
    }
  };

  function constant(x) {
    return function constant() {
      return x;
    };
  }

  function x(p) {
    return p[0];
  }

  function y(p) {
    return p[1];
  }

  var slice = Array.prototype.slice;

  function linkSource(d) {
    return d.source;
  }

  function linkTarget(d) {
    return d.target;
  }

  function link(curve) {
    var source = linkSource,
        target = linkTarget,
        x$1 = x,
        y$1 = y,
        context = null;

    function link() {
      var buffer, argv = slice.call(arguments), s = source.apply(this, argv), t = target.apply(this, argv);
      if (!context) context = buffer = path();
      curve(context, +x$1.apply(this, (argv[0] = s, argv)), +y$1.apply(this, argv), +x$1.apply(this, (argv[0] = t, argv)), +y$1.apply(this, argv));
      if (buffer) return context = null, buffer + "" || null;
    }

    link.source = function(_) {
      return arguments.length ? (source = _, link) : source;
    };

    link.target = function(_) {
      return arguments.length ? (target = _, link) : target;
    };

    link.x = function(_) {
      return arguments.length ? (x$1 = typeof _ === "function" ? _ : constant(+_), link) : x$1;
    };

    link.y = function(_) {
      return arguments.length ? (y$1 = typeof _ === "function" ? _ : constant(+_), link) : y$1;
    };

    link.context = function(_) {
      return arguments.length ? ((context = _ == null ? null : _), link) : context;
    };

    return link;
  }

  function curveHorizontal(context, x0, y0, x1, y1) {
    context.moveTo(x0, y0);
    context.bezierCurveTo(x0 = (x0 + x1) / 2, y0, x0, y1, x1, y1);
  }

  function linkHorizontal() {
    return link(curveHorizontal);
  }

  function horizontalSource(d) {
    return [d.source.x1, d.y0];
  }

  function horizontalTarget(d) {
    return [d.target.x0, d.y1];
  }

  function sankeyLinkHorizontal() {
    return linkHorizontal()
        .source(horizontalSource)
        .target(horizontalTarget);
  }

  /**
   * This example shows how to use an external library into a custom visualization.
   * The 'd3-sankey' library used in this example was added to 'package.json' and
   * imported in this Main.ts file. It is used to calculate Sankey paths.
   * This sample also shows how to deal with hit-testing in case the nodes that are
   * generated have an indirect link to the data. The 'hitTest' method in this sample
   * shows how to do this.
   */
  // Data column indices (see vizdef.xml).

  var FROM = 0,
      TO = 1,
      WEIGHT = 2; // Carbon color palette

  var PALETTE = ["#6929c4", "#1192e8", "#005d5d", "#9f1853", "#fa4d56", "#570408", "#198038", "#002d9c", "#ee538b", "#b28600", "#009d9a", "#022b30", "#8a3800", "#a56eff"]; // Key function that uniquely identifies data elements. Used in 'update'.

  var keyFn = function keyFn(elem) {
    return elem.key || "";
  }; // Creates empty paths for each link between two nodes. Called during 'update' when
  // new data needs to be rendered.


  function createLinks(_selection) {
    // Create a linear gradient and a stroke refering to that gradient.
    var id = Math.random().toString(36).substr(2); // claim a new gradient id.

    var gradient = function gradient(i) {
      return "grad_".concat(id, ":").concat(i);
    };

    _selection.style("mix-blend-mode", "multiply").append("linearGradient").attr("gradientUnits", "userSpaceOnUse").attr("id", function (_, i) {
      return gradient(i);
    }).call(function (g) {
      return g.append("stop").attr("offset", "0%");
    }).call(function (g) {
      return g.append("stop").attr("offset", "100%");
    });

    _selection.append("path").attr("stroke", function (_, i) {
      return "url(#".concat(gradient(i), ")");
    });
  }

  var Sankey = /*#__PURE__*/function (_RenderBase) {
    _inherits(Sankey, _RenderBase);

    var _super = _createSuper(Sankey);

    function Sankey() {
      _classCallCheck(this, Sankey);

      return _super.apply(this, arguments);
    }

    _createClass(Sankey, [{
      key: "hitTest",
      value: // Custom hitTest method to return the data point or tuple that was hit.
      function hitTest(_elem) {
        // Data is stored in the '$' field of each d3 datum.
        var elem = d3__namespace.select(_elem).datum();
        return elem && elem.$;
      } // Initial setup of the visualization.

    }, {
      key: "create",
      value: function create(_parent) {
        // Create an svg canvas with groups for nodes, links and labels.
        var svg = d3__namespace.select(_parent).append("svg").attr("width", "100%").attr("height", "100%").style("position", "absolute");
        svg.append("g").attr("class", "nodes").attr("stroke", "#000");
        svg.append("g").attr("class", "links").attr("fill", "none");
        svg.append("g").attr("class", "labels"); // Return the svg element so it can be used in the `update` method.

        return svg.node();
      } // Called every time the visualization needs updating.

    }, {
      key: "update",
      value: function update(_info) {
        // Retrieve svg node (see `create`) and determine size.
        var svg = d3__namespace.select(_info.node);
        var width = _info.node.clientWidth;
        var height = _info.node.clientHeight;
        var data = _info.data; // If there is no data, remove everything from the canvas and exit.

        if (!data || !data.rows.length) {
          svg.selectAll("g>*").remove();
          return;
        } // Generate data structure for Sankey. Note the prefix that is used for the source
        // and target node. This is done to prevent circular links in case the FROM and TO
        // columns are mapped to the same data item. The field '$' is added to each link to
        // store a reference to the original data row (needed for hit testing support).
        // The nodes are created from the tuples in the 'from' and 'to' slots. Notice that
        // we use a 'filter' operation on the nodes to remove nodes that are not used in any
        // links. This is to prevent rendering unnecessary 'empty' nodes.


        var keys = new Set(); // source and target keys, needed to delete unused nodes

        var links = data.rows.map(function (_row) {
          var link = {
            source: "F:".concat(_row.tuple(FROM).key),
            target: "T:".concat(_row.tuple(TO).key),
            value: Math.abs(_row.value(WEIGHT)),
            // negative values are not allowed
            key: _row.key,
            $: _row
          };
          keys.add(link.source).add(link.target);
          return link;
        });
        var fromNodes = data.cols[FROM].tuples.map(function (t) {
          return {
            $: t,
            key: "F:".concat(t.key)
          };
        });
        var toNodes = data.cols[TO].tuples.map(function (t) {
          return {
            $: t,
            key: "T:".concat(t.key)
          };
        });
        var nodes = fromNodes.concat(toNodes).filter(function (_node) {
          return keys.has(_node.key);
        }); // Generate sankey data from the data structures.

        var createSankey = Sankey$1().nodeId(function (n) {
          return n.key;
        }).nodeWidth(15) // width (in px) of a node rectangle
        .linkSort(null) // links are in row order
        .nodeSort(null) // nodes are in tuple order
        .size([width, height]); // size of the visualization

        createSankey({
          nodes: nodes,
          links: links
        }); // generate Sankey data
        // An ordinal color scale assigns a new color to each unique node, using our defined palette.

        var colors = d3__namespace.scaleOrdinal().range(PALETTE); // Update nodes. Ensure that tuples are colored based on tuple key.

        svg.select(".nodes").selectAll("rect").data(nodes, keyFn).join("rect").attr("x", function (d) {
          return d.x0;
        }).attr("y", function (d) {
          return d.y0;
        }).attr("height", function (d) {
          return Math.max(0, d.y1 - d.y0);
        }).attr("width", function (d) {
          return d.x1 - d.x0;
        }).attr("stroke-width", 0).attr("fill", function (d) {
          return colors(d.$.key).toString();
        }); // node color
        // Update links that connect the nodes. From and to colors are based on tuple key.

        svg.select(".links").selectAll("g").data(links, keyFn).join(function (enter) {
          return enter.append("g").call(createLinks);
        }).call(function (g) // 'g' represents a link with a path and linearGradient
        {
          g.attr("stroke-opacity", function (d) {
            return d.$.highlighted || d.$.selected ? 1 : 0.4;
          });
          g.select("linearGradient") // gradient offsets
          .attr("x1", function (d) {
            return d.source.x1;
          }).attr("x2", function (d) {
            return d.source.x2;
          });
          g.select("stop:nth-of-type(1)") // 'from' color
          .attr("stop-color", function (d) {
            return colors(d.source.$.key).toString();
          });
          g.select("stop:nth-of-type(2)") // 'to' color
          .attr("stop-color", function (d) {
            return colors(d.target.$.key).toString();
          });
          g.select("path") // uses the generated path in 'links'
          .attr("d", sankeyLinkHorizontal()).attr("stroke-width", function (d) {
            return Math.max(1, d.width);
          });
        }); // Update labels for each node.

        svg.select(".labels").selectAll("text").data(nodes, keyFn).join("text").attr("x", function (d) {
          return d.x0 < width / 2 ? d.x1 + 6 : d.x0 - 6;
        }) // 6px margin
        .attr("y", function (d) {
          return (d.y1 + d.y0) / 2;
        }) // center vertically
        .attr("dy", "0.35em") // offset to center of the node
        .attr("text-anchor", function (d) {
          return d.x0 < width / 2 ? "start" : "end";
        }) // alignment
        .attr("font-weight", function (d) {
          return d.$.selected ? "bold" : "normal";
        }) // bold if selected
        .text(function (d) {
          return d.$.caption;
        }); // use the tuple caption
      }
    }]);

    return Sankey;
  }(st);

  return Sankey;

}));
